-- macro:
-- #showtooltip
-- /ShamanMount ground_mount_name,flying_mount_name,shift_mount_name,ctrl_mount_name,alt_mount_name
-- /click ShamanMount

CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")
ShamanMountData = {}

local GhostWolf = GetSpellInfo(2645)
local WaterWalking = GetSpellInfo(546)
local AbyssalSeahorse = GetSpellInfo(75207)
local SubduedSeaHorse = GetSpellInfo(98718)
local SeaTurtle = GetSpellInfo(64731)
local CrimsonWaterStrider = GetSpellInfo(87791)
local AzureWaterStrider = GetSpellInfo(118089)
local ExpertRiding
local ArtisanRiding
local MasterRiding
local FlightMastersLicense
local ColdWeatherFlying
local WisdomoftheFourWinds
local WaterWalkingMacro = "/cast [@player]"..WaterWalking.."\n"
local GarrisonMacro = "/cast "..GetSpellInfo(161691)
local timer = GetTime()
local _,Class = UnitClass("player")
local IsVashjir
local AbyssalOk
local SeaHorseOk
local SeaTurtleOk
local GarrisonMountOk
local Grommashar = 1329

local GMN,FMN,SMN,CMN,AMN,MacroName

local function CanFly()
	local zone
	_,_,_,_,_,_,_,zone = GetInstanceInfo()
	if (zone==0 or zone==1 or zone==646) and FlightMastersLicense then
		return true
	elseif zone==530 and (ExpertRiding or ArtisanRiding or MasterRiding) then
		return true
	elseif zone==571 and ColdWeatherFlying then
		return true
	elseif zone==870 and WisdomoftheFourWinds then
		return true
	end  
	return false
end

SLASH_SHAMANMOUNT1 = "/ShamanMount"
SlashCmdList["SHAMANMOUNT"] = function(msg)
	GMN,FMN,SMN,CMN,AMN = msg:match("%s*([^,]*)%s*,?%s*([^,]*)%s*,?%s*([^,]*)%s*,?%s*([^,]*)%s*,?%s*([^,]*)%s*")
	if GMN then
		GMN = string.upper(GMN:gsub("%s*$",""))
	end
	if FMN then
		FMN = string.upper(FMN:gsub("%s*$",""))
	else
		FMN = GMN
	end
	if SMN then
		SMN = string.upper(SMN:gsub("%s*$",""))
	end
	if CMN then
		CMN = string.upper(CMN:gsub("%s*$",""))
	end
	if AMN then
		AMN = string.upper(AMN:gsub("%s*$",""))
	end

	local InstanceType 
	local IsMoving = GetUnitSpeed("player")~=0
	local AzureOk = IsUsableSpell(AzureWaterStrider)
	local CrimsonOk = IsUsableSpell(CrimsonWaterStrider)
	local JustSubmerged = IsSubmerged() and GetTime()-timer<1.0
	local FlyingOk = IsUsableSpell(FMN) and IsFlyableArea() and CanFly() or FMN=="RANDOM" and IsOutdoors()
	local GroundOk = IsUsableSpell(GMN) or GMN=="RANDOM" and IsOutdoors()
	local ShiftOk = IsUsableSpell(SMN) or SMN=="RANDOM" and IsOutdoors()
	local CtrlOk = IsUsableSpell(CMN) or CMN=="RANDOM" and IsOutdoors()
	local AltOk = IsUsableSpell(AMN) or AMN=="RANDOM" and IsOutdoors()
	local nobg
	local zone

	_,_,_,_,_,_,_,zone = GetInstanceInfo()
	MacroName = GetMacroInfo(GetRunningMacro())
	IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
	AbyssalOk = IsUsableSpell(AbyssalSeahorse)
	SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
	SeaTurtleOk = IsUsableSpell(SeaTurtle)
	GarrisonMountOk = string.match(select(3,GetSpellInfo(161691)),"mount") and IsOutdoors()
	_,InstanceType = IsInInstance()
	nobg = IsInInstance()~="pvp"

	ShamanMountData["MacroName"] = MacroName
	ShamanMountData["GroundMountName"] = GMN
	ShamanMountData["FlyingMountName"] = FMN
	ShamanMountData["ShiftMountName"] = SMN
	ShamanMountData["CtrlMountName"] = CMN
	ShamanMountData["AltMountName"] = AMN
	
	if not InCombatLockdown() then
		ShamanMount:SetAttribute("type","macro")
		if CanExitVehicle() then
			ShamanMount:SetAttribute("macrotext","/run VehicleExit()")
		elseif IsMounted() then
			ShamanMount:SetAttribute("macrotext","/dismount [noflying]")
		elseif IsShiftKeyDown() and ShiftOk and SMN=="RANDOM" then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/run C_MountJournal.Summon(0)")
		elseif IsShiftKeyDown() and ShiftOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SMN)
		elseif IsControlKeyDown() and CtrlOk and CMN=="RANDOM" then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/run C_MountJournal.Summon(0)")
		elseif IsControlKeyDown() and CtrlOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..CMN)
		elseif IsAltKeyDown() and AltOk and AMN=="RANDOM" then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/run C_MountJournal.Summon(0)")
		elseif IsAltKeyDown() and AltOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AMN)
		elseif Class=="SHAMAN" and GetShapeshiftForm()==1 then
			ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
		elseif IsMoving then
			ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
		elseif JustSubmerged and FlyingOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
		elseif JustSubmerged and CrimsonOk and nobg and Class~="SHAMAN" then
			ShamanMount:SetAttribute("macrotext","/cast "..CrimsonWaterStrider)
		elseif JustSubmerged and AzureOk and nobg and Class~="SHAMAN" then
			ShamanMount:SetAttribute("macrotext","/cast "..AzureWaterStrider)
		elseif IsVashjir and AbyssalOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AbyssalSeahorse)
		elseif SeaTurtleOk and IsSubmerged() then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SeaTurtle)
		elseif SeaHorseOk then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SubduedSeahorse)
		elseif FlyingOk and IsSubmerged() and FMN=="RANDOM" then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/run C_MountJournal.Summon(0)")
		elseif FlyingOk and FMN=="RANDOM" then
			ShamanMount:SetAttribute("macrotext","/run C_MountJournal.Summon(0)")
		elseif FlyingOk and IsSubmerged() then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
		elseif FlyingOk then
			ShamanMount:SetAttribute("macrotext","/cast "..FMN)
		elseif GarrisonMountOk and (zone~=Grommashar or Class~="SHAMAN") then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro..GarrisonMacro)
        elseif GroundOk and GMN=="RANDOM" and (zone~=Grommashar or Class~="SHAMAN") then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/run C_MountJournal.Summon(0)")
		elseif GroundOk and (zone~=Grommashar or Class~="SHAMAN") then
			ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..GMN)
		else
			ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
		end
	end
end

ShamanMount:SetScript("OnEvent",function(self,event)
	IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
	AbyssalOk = IsUsableSpell(AbyssalSeahorse)
	SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
	SeaTurtleOk = IsUsableSpell(SeaTurtle)
	local zone
	_,_,_,_,_,_,_,zone = GetInstanceInfo()
	GarrisonMountOk = string.match(select(3,GetSpellInfo(161691)),"mount") and IsOutdoors()
	if event=="PLAYER_LOGIN" then
		MacroName = ShamanMountData["MacroName"]
		GMN = ShamanMountData["GroundMountName"]
		FMN = ShamanMountData["FlyingMountName"]
		SMN = ShamanMountData["ShiftMountName"]
		CMN = ShamanMountData["CtrlMountName"]
		AMN = ShamanMountData["AltMountName"]
		ExpertRiding = IsSpellKnown(34090)
		ArtisanRiding = IsSpellKnown(34091)
		MasterRiding = IsSpellKnown(90265)
		FlightMastersLicense = IsSpellKnown(90267)
		ColdWeatherFlying = IsSpellKnown(54197)
		WisdomoftheFourWinds = IsSpellKnown(115913)
	end
	if event=="PLAYER_REGEN_DISABLED" then
		ShamanMount:UnregisterEvent("SPELL_UPDATE_USABLE")
		ShamanMount:UnregisterEvent("MODIFIER_STATE_CHANGED")
		ShamanMount:SetAttribute("type","macro")
		if GarrisonMountOk and (zone~=Grommashar or Class~="SHAMAN") then
			UIErrorsFrame:Hide()
			ShamanMount:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n"..GarrisonMacro.."\n/cast [nomounted]"..GhostWolf)
		else
			ShamanMount:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n/cast [nomounted]"..GhostWolf.."\n/dismount [noflying]")
		end
	end
	if event=="PLAYER_REGEN_ENABLED" then
		UIErrorsFrame:Clear()
		UIErrorsFrame:Show()
		ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
		ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")
	end
	if event=="SPELL_UPDATE_USABLE" and not IsSubmerged() then
		timer = GetTime()
	end
	if IsShiftKeyDown() and IsUsableSpell(SMN) then
		SetMacroSpell(MacroName,SMN)
	elseif IsControlKeyDown() and IsUsableSpell(CMN) then
		SetMacroSpell(MacroName,CMN)
	elseif IsAltKeyDown() and IsUsableSpell(AMN) then
		SetMacroSpell(MacroName,AMN)
	elseif GarrisonMountOk and (zone~=Grommashar or Class~="SHAMAN") then
		SetMacroSpell(MacroName,GetSpellInfo(161691))
	elseif IsVashjir and IsSubmerged() and (AbyssalOk or Class~="SHAMAN" and GetSpellInfo(AbyssalSeahorse)) then
		SetMacroSpell(MacroName,AbyssalSeahorse)
	elseif IsSubmerged() and (SeaHorseOk or Class~="SHAMAN" and GetSpellInfo(SubduedSeahorse)) then
		SetMacroSpell(MacroName,SubduedSeahorse)
	elseif IsSubmerged() and (SeaTurtleOk or Class~="SHAMAN" and GetSpellInfo(SeaTurtle)) then
		SetMacroSpell(MacroName,SeaTurtle)
	elseif IsFlyableArea() and CanFly() and (FMN=="RANDOM" or IsUsableSpell(FMN) or Class~="SHAMAN" and GetSpellInfo(FMN)) then
		SetMacroSpell(MacroName,FMN)
	elseif (GMN=="RANDOM" or IsUsableSpell(GMN) or Class~="SHAMAN" and GetSpellInfo(GMN)) and (zone~=Grommashar or Class~="SHAMAN") then
		SetMacroSpell(MacroName,GMN)
	elseif Class=="SHAMAN" then
		SetMacroSpell(MacroName,GhostWolf)
	end
end)

ShamanMount:RegisterEvent("PLAYER_LOGIN")
ShamanMount:RegisterEvent("PLAYER_REGEN_ENABLED")
ShamanMount:RegisterEvent("PLAYER_REGEN_DISABLED")
ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
ShamanMount:RegisterEvent("UPDATE_MACROS")
ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")